// PropPage1.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "PropPage1.h"
#include "Database.h"
#include "CeDB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropPage1 property page

IMPLEMENT_DYNCREATE(CPropPage1, CPropertyPage)

CPropPage1::CPropPage1() : CPropertyPage(CPropPage1::IDD)
{
	//{{AFX_DATA_INIT(CPropPage1)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPropPage1::~CPropPage1()
{
}

void CPropPage1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPage1)
	DDX_Control(pDX, IDLV_OVERVIEW, m_lcOverview);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPage1)
	ON_NOTIFY(LVN_ITEMCHANGED, IDLV_OVERVIEW, OnItemchangedOverview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropPage1 message handlers

BOOL CPropPage1::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Create columns in the list view control
	m_lcOverview.InsertColumn(0, TEXT("Title"), LVCFMT_LEFT, 155);
	m_lcOverview.InsertColumn(1, TEXT("Rating"), LVCFMT_LEFT, 60);

	// Set the extended style such that it selects the entire row
	m_lcOverview.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPropPage1::OnSetActive() 
{
	// Seek to the beginning of a populated database
	g_DB.SeekDB(CEDB_SEEK_BEGINNING);

	// Clear list view control
	m_lcOverview.DeleteAllItems();

	// Fill list view with elements from database
	int nCount = 0;
	CRecord record;
	bool bResult = g_DB.ReadRecord(record);
	while(bResult)
	{	
		// Add the title of the current movie to the list view
		m_lcOverview.InsertItem(
			nCount,					// position to insert the item
			record.m_strTitle);

		// Add the rating of the current movie to the list view
		CString strRating;
		strRating.Format(TEXT("%.2f"), record.m_fRating);
		m_lcOverview.SetItemText(
			nCount++,				// position to insert the item
			1,						// subitem number
			strRating);

		// Seek to the next record
		bResult = g_DB.SeekDB(CEDB_SEEK_CURRENT, 1);

		// Attempt to read the record if seek was successful
		if(bResult)
			bResult = g_DB.ReadRecord(record);
	}

	CCeDBApp *pCeDBApp = (CCeDBApp *)AfxGetApp();

	// Make sure that there is at least one item in the list view
	if(m_lcOverview.GetItemCount() < 1)
		pCeDBApp->m_nItem = -1;
	else
	// Select the currently active database record
	m_lcOverview.SetItemState(pCeDBApp->m_nItem, LVIS_SELECTED, LVIS_SELECTED);
	
	return CPropertyPage::OnSetActive();
}

BOOL CPropPage1::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	int idCtrl = wParam;
	NMHDR *pnmhdr = (LPNMHDR)lParam;

	if(pnmhdr->code == pnmhdr->idFrom)
	{
		NMLISTVIEW *pnmlv = (NMLISTVIEW *)pnmhdr;

		// Create popup menu for delete and track 
		CMenu Menu;
		Menu.CreatePopupMenu();
		Menu.AppendMenu(MF_STRING, 0, TEXT("Delete"));
		Menu.TrackPopupMenu(TPM_LEFTALIGN, pnmlv->iItem, pnmlv->iSubItem, this);


	}
/*
	CString str;
	str.Format(L"%d %d %d\n", pnmhdr->hwndFrom, pnmhdr->idFrom, pnmhdr->code);
	OutputDebugString(str);

	if((pnmhdr) && (pnmhdr->hwndFrom == m_lcOverview.m_hWnd))
	{
		NMLISTVIEW *pnmlv = (NMLISTVIEW *)pnmhdr;

		//if(pnmhdr->code < LVN_FIRST && pnmhdr->code > LVN_LAST)
		{
			CString str;
			str.Format(L"%d %d %d %d %d\n", pnmlv->iItem, pnmlv->iSubItem, pnmlv->uNewState, pnmlv->uOldState, pnmlv->uChanged);
			OutputDebugString(str);
		}
	}*/

	return CPropertyPage::OnNotify(wParam, lParam, pResult);
}

void CPropPage1::OnItemchangedOverview(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	// Set global selection variable if item changes selection
	if(pNMListView->uNewState == 3)
	{
		CCeDBApp *pCeDBApp = (CCeDBApp *)AfxGetApp();
		pCeDBApp->m_nItem = pNMListView->iItem;
	}

	*pResult = 0;

}

BOOL CPropPage1::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// Delete the currently selected record
	CCeDBApp *pCeDBApp = (CCeDBApp *)AfxGetApp();

	// If no item is selected, return
	if(pCeDBApp->m_nItem < 0)
		return 0;

	// Otherwise delete the record2
	g_DB.DeleteRecord(pCeDBApp->m_nItem);

	// Redisplay the listview control
	OnSetActive();

	// Gets and sets the selection mark
	if(m_lcOverview.GetSelectionMark() == -1)
	{
		int nCount = m_lcOverview.GetItemCount();
		if(nCount > 0)
		{
			// Set selection item state
			m_lcOverview.SetItemState(nCount - 1, LVIS_SELECTED, LVIS_SELECTED);
		}

		// Set global selection variable
		CCeDBApp *pCeDBApp = (CCeDBApp *)AfxGetApp();
		pCeDBApp->m_nItem = nCount - 1;
	}


	return CPropertyPage::OnCommand(wParam, lParam);
}
